version: '3.7'
services:
  zookeeper1-1:
    container_name: "zookeeper1-1"
    image: "confluentinc/cp-zookeeper:7.1.1"
    hostname: "zookeeper1-1.net"
    ports:
      - 127.0.0.1:2281:2281 #SecureClientPort
      - 127.0.0.1:2888:2888 #For follower connections, if they are the leader
      - 127.0.0.1:3888:3888 #For other server connections during the leader election phase

    environment:
      ZOOKEEPER_SERVER_ID: 1
      ZOOKEEPER_SERVERS: zookeeper1-1.net:2888:3888; zookeeper1-2.net:2888:3888; zookeeper1-3.net:2888:3888
      ZOOKEEPER_TICK_TIME: 2000
      ZOOKEEPER_INIT_LIMIT: 300
      ZOOKEEPER_SYNC_LIMIT: 10
      ZOOKEEPER_MAX_CLIENT_CNXNS: 2000
      ZOOKEEPER_STANDALONE_ENABLED: 'false'
##
#ZOO
##
      ZOOKEEPER_SSL_QUORUM: 'true'
      ZOOKEEPER_SERVER_CNXN_FACTORY: 'org.apache.zookeeper.server.NettyServerCnxnFactory'
      ZOOKEEPER_SSL_QUORUM_KEYSTORE_LOCATION: /tmp/server/security/zookeeper1-1.net.p12
      ZOOKEEPER_SSL_QUORUM_KEYSTORE_PASSWORD: strong
      ZOOKEEPER_SSL_QUORUM_TRUSTSTORE_LOCATION: /tmp/server/security/truststore.p12
      ZOOKEEPER_SSL_QUORUM_TRUSTSTORE_PASSWORD: strong

      ZOOKEEPER_AUTH_PROVIDER_SASL: 'org.apache.zookeeper.server.auth.SASLAuthenticationProvider'
##
#Broker
##
      ZOOKEEPER_CLIENT_SECURE: "true"
      ZOOKEEPER_SECURE_CLIENT_PORT: 2281
      ZOOKEEPER_CLIENT_PORT: 2181
      ZOOKEEPER_AUTH_PROVIDER_X509: 'org.apache.zookeeper.server.auth.X509AuthenticationProvider'
      ZOOKEEPER_SSL_KEYSTORE_LOCATION: /tmp/client/security/zookeeper1-1.net-keystore.jks
      ZOOKEEPER_SSL_KEYSTORE_PASSWORD: strong
      ZOOKEEPER_SSL_TRUSTSTORE_LOCATION: /tmp/client/security/zookeeper1-1.net-trustore.jks
      ZOOKEEPER_SSL_TRUSTSTORE_PASSWORD: strong

      ZOOKEEPER_JAASLOGINRENEW: 3600000
#####
##SASL_SSL/PLAIN Configs
#####
      KAFKA_OPTS: "-Djava.security.auth.login.config=/etc/kafka/zookeeper_jaas.conf -Dzookeeper.authProvider.1=org.apache.zookeeper.server.auth.SASLAuthenticationProvider -Dzookeeper.requireClientAuthScheme=sasl -Dzookeeper.allowSaslFailedClients=false -Dzookeeper.sessionRequireClientSASLAuth=true -Dzookeeper.sasl.client=true"

    volumes:
      - ./zookeeper1-1/data:/data
      - ./zookeeper1-1/datalog:/datalog
      - ./zookeeper1-1/conf:/conf
      - ./zookeeper1-1/security/server:/tmp/server/security
      - ./zookeeper1-1/security/client:/tmp/client/security
      - ./zookeeper1-1/sasl/zookeeper_jaas.conf:/etc/kafka/zookeeper_jaas.conf

    restart: always

    logging:
      driver: "json-file"
      options:
        max-size: "100m"
        max-file: "1"

    networks:
      - kafka

networks:
  kafka:
    name: kafka
    driver: bridge
